﻿Type=Class
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Event: Click
#DesignerProperty: Key: Rotation, DisplayName: Rotation, FieldType: String, DefaultValue: NONE, List: NONE|CLOCKWISE|ANTICLOCKWISE
Sub Class_Globals
	Private EventName As String 'ignore
	Private CallBack As Object 'ignore
	Private mBase As Panel
	Private innerLabel As Label
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	EventName = vEventName
	CallBack = vCallback
	
	mBase.Initialize("")
	
End Sub

Public Sub DesignerCreateView (Base As Panel, lbl As Label, Props As Map)
	mBase = Base
	For Each key As String In Props.keys
		Select key
			Case "Rotation"
				Select Props.Get(key)
					Case "CLOCKWISE"
						RotateView(mBase, True)
					Case "ANTICLOCKWISE"
						RotateView(mBase, False)
					Case Else						
						
				End Select			
		End Select
	Next
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub
Public Sub Rotate (clockwise As Boolean)
	RotateView(mBase, clockwise)
End Sub

private Sub RotateView (vw As View, clockwise As Boolean)

	Dim centre_x As Float
	Dim centre_y As Float
	Dim height   As Int = vw.height

	Dim RotateDegrees As String
	
	If clockwise Then
		RotateDegrees = "90"
	Else
		RotateDegrees = "270"
	End If

	centre_x  = vw.left + (vw.width/2)
	centre_y  = vw.top  + (vw.height/2)
	vw.top    = centre_y - (vw.width/2)
	vw.left   = centre_x - (vw.height/2)		
	vw.height = vw.Width
	vw.width  = height

	Dim Reflect As Reflector
	Reflect.Target = vw
	Reflect.RunMethod2("setRotation",RotateDegrees,"java.lang.float")

End Sub